Index: trunk/ab5.0/ablib/src/Classes/System/Drawing/Imaging/misc.ab
===================================================================
--- trunk/ab5.0/ablib/src/Classes/System/Drawing/Imaging/misc.ab	(revision 698)
+++ trunk/ab5.0/ablib/src/Classes/System/Drawing/Imaging/misc.ab	(revision 700)
@@ -436,4 +436,332 @@
 End Enum
 
+Enum MetafileType
+	Invalid
+	Wmf
+	WmfPlaceable
+	Emf
+	EmfPlusOnly
+	EmfPlusDual
+End Enum
+
+Enum EmfType
+	Only     = 4 'MetafileType.Emf As Long
+	PlusOnly = 5 'MetafileType.EmfPlusOnly As Long
+	PlusDual = 6 'MetafileType.EmfPlusDual As Long
+End Enum
+
+Enum EncoderParameterValueType
+	Byte           = 1
+	ASCII          = 2
+	Short          = 3
+	Long           = 4
+	Rational       = 5
+	LongRange      = 6
+	Undefined      = 7
+	RationalRange  = 8
+End Enum
+
+Enum EncoderValue
+	ColorTypeCMYK
+	ColorTypeYCCK
+	CompressionLZW
+	CompressionCCITT3
+	CompressionCCITT4
+	CompressionRle
+	CompressionNone
+	ScanMethodInterlaced
+	ScanMethodNonInterlaced
+	VersionGif87
+	VersionGif89
+	RenderProgressive
+	RenderNonProgressive
+	TransformRotate90
+	TransformRotate180
+	TransformRotate270
+	TransformFlipHorizontal
+	TransformFlipVertical
+	MultiFrame
+	LastFrame
+	Flush
+	FrameDimensionTime
+	FrameDimensionResolution
+	FrameDimensionPage
+End Enum
+
+Enum EmfPlusRecordType
+	WmfSetBkColor              = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETBKCOLOR)
+	WmfSetBkMode               = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETBKMODE)
+	WmfSetMapMode              = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETMAPMODE)
+	WmfSetROP2                 = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETROP2)
+	WmfSetRelAbs               = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETRELABS)
+	WmfSetPolyFillMode         = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETPOLYFILLMODE)
+	WmfSetStretchBltMode       = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETSTRETCHBLTMODE)
+	WmfSetTextCharExtra        = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETTEXTCHAREXTRA)
+	WmfSetTextColor            = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETTEXTCOLOR)
+	WmfSetTextJustification    = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETTEXTJUSTIFICATION)
+	WmfSetWindowOrg            = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETWINDOWORG)
+	WmfSetWindowExt            = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETWINDOWEXT)
+	WmfSetViewportOrg          = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETVIEWPORTORG)
+	WmfSetViewportExt          = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETVIEWPORTEXT)
+	WmfOffsetWindowOrg         = GDIP_WMF_RECORD_TO_EMFPLUS(META_OFFSETWINDOWORG)
+	WmfScaleWindowExt          = GDIP_WMF_RECORD_TO_EMFPLUS(META_SCALEWINDOWEXT)
+	WmfOffsetViewportOrg       = GDIP_WMF_RECORD_TO_EMFPLUS(META_OFFSETVIEWPORTORG)
+	WmfScaleViewportExt        = GDIP_WMF_RECORD_TO_EMFPLUS(META_SCALEVIEWPORTEXT)
+	WmfLineTo                  = GDIP_WMF_RECORD_TO_EMFPLUS(META_LINETO)
+	WmfMoveTo                  = GDIP_WMF_RECORD_TO_EMFPLUS(META_MOVETO)
+	WmfExcludeClipRect         = GDIP_WMF_RECORD_TO_EMFPLUS(META_EXCLUDECLIPRECT)
+	WmfIntersectClipRect       = GDIP_WMF_RECORD_TO_EMFPLUS(META_INTERSECTCLIPRECT)
+	WmfArc                     = GDIP_WMF_RECORD_TO_EMFPLUS(META_ARC)
+	WmfEllipse                 = GDIP_WMF_RECORD_TO_EMFPLUS(META_ELLIPSE)
+	WmfFloodFill               = GDIP_WMF_RECORD_TO_EMFPLUS(META_FLOODFILL)
+	WmfPie                     = GDIP_WMF_RECORD_TO_EMFPLUS(META_PIE)
+	WmfRectangle               = GDIP_WMF_RECORD_TO_EMFPLUS(META_RECTANGLE)
+	WmfRoundRect               = GDIP_WMF_RECORD_TO_EMFPLUS(META_ROUNDRECT)
+	WmfPatBlt                  = GDIP_WMF_RECORD_TO_EMFPLUS(META_PATBLT)
+	WmfSaveDC                  = GDIP_WMF_RECORD_TO_EMFPLUS(META_SAVEDC)
+	WmfSetPixel                = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETPIXEL)
+	WmfOffsetClipRgn           = GDIP_WMF_RECORD_TO_EMFPLUS(META_OFFSETCLIPRGN)
+	WmfTextOut                 = GDIP_WMF_RECORD_TO_EMFPLUS(META_TEXTOUT)
+	WmfBitBlt                  = GDIP_WMF_RECORD_TO_EMFPLUS(META_BITBLT)
+	WmfStretchBlt              = GDIP_WMF_RECORD_TO_EMFPLUS(META_STRETCHBLT)
+	WmfPolygon                 = GDIP_WMF_RECORD_TO_EMFPLUS(META_POLYGON)
+	WmfPolyline                = GDIP_WMF_RECORD_TO_EMFPLUS(META_POLYLINE)
+	WmfEscape                  = GDIP_WMF_RECORD_TO_EMFPLUS(META_ESCAPE)
+	WmfRestoreDC               = GDIP_WMF_RECORD_TO_EMFPLUS(META_RESTOREDC)
+	WmfFillRegion              = GDIP_WMF_RECORD_TO_EMFPLUS(META_FILLREGION)
+	WmfFrameRegion             = GDIP_WMF_RECORD_TO_EMFPLUS(META_FRAMEREGION)
+	WmfInvertRegion            = GDIP_WMF_RECORD_TO_EMFPLUS(META_INVERTREGION)
+	WmfPaintRegion             = GDIP_WMF_RECORD_TO_EMFPLUS(META_PAINTREGION)
+	WmfSelectClipRegion        = GDIP_WMF_RECORD_TO_EMFPLUS(META_SELECTCLIPREGION)
+	WmfSelectObject            = GDIP_WMF_RECORD_TO_EMFPLUS(META_SELECTOBJECT)
+	WmfSetTextAlign            = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETTEXTALIGN)
+	WmfDrawText                = GDIP_WMF_RECORD_TO_EMFPLUS(&h062F)   ' META_DRAWTEXT
+	WmfChord                   = GDIP_WMF_RECORD_TO_EMFPLUS(META_CHORD)
+	WmfSetMapperFlags          = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETMAPPERFLAGS)
+	WmfExtTextOut              = GDIP_WMF_RECORD_TO_EMFPLUS(META_EXTTEXTOUT)
+	WmfSetDIBToDev             = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETDIBTODEV)
+	WmfSelectPalette           = GDIP_WMF_RECORD_TO_EMFPLUS(META_SELECTPALETTE)
+	WmfRealizePalette          = GDIP_WMF_RECORD_TO_EMFPLUS(META_REALIZEPALETTE)
+	WmfAnimatePalette          = GDIP_WMF_RECORD_TO_EMFPLUS(META_ANIMATEPALETTE)
+	WmfSetPalEntries           = GDIP_WMF_RECORD_TO_EMFPLUS(META_SETPALENTRIES)
+	WmfPolyPolygon             = GDIP_WMF_RECORD_TO_EMFPLUS(META_POLYPOLYGON)
+	WmfResizePalette           = GDIP_WMF_RECORD_TO_EMFPLUS(META_RESIZEPALETTE)
+	WmfDIBBitBlt               = GDIP_WMF_RECORD_TO_EMFPLUS(META_DIBBITBLT)
+	WmfDIBStretchBlt           = GDIP_WMF_RECORD_TO_EMFPLUS(META_DIBSTRETCHBLT)
+	WmfDIBCreatePatternBrush   = GDIP_WMF_RECORD_TO_EMFPLUS(META_DIBCREATEPATTERNBRUSH)
+	WmfStretchDIB              = GDIP_WMF_RECORD_TO_EMFPLUS(META_STRETCHDIB)
+	WmfExtFloodFill            = GDIP_WMF_RECORD_TO_EMFPLUS(META_EXTFLOODFILL)
+	WmfSetLayout               = GDIP_WMF_RECORD_TO_EMFPLUS(&h0149)   ' META_SETLAYOUT
+	WmfResetDC                 = GDIP_WMF_RECORD_TO_EMFPLUS(&h014C)   ' META_RESETDC
+	WmfStartDoc                = GDIP_WMF_RECORD_TO_EMFPLUS(&h014D)   ' META_STARTDOC
+	WmfStartPage               = GDIP_WMF_RECORD_TO_EMFPLUS(&h004F)   ' META_STARTPAGE
+	WmfEndPage                 = GDIP_WMF_RECORD_TO_EMFPLUS(&h0050)   ' META_ENDPAGE
+	WmfAbortDoc                = GDIP_WMF_RECORD_TO_EMFPLUS(&h0052)   ' META_ABORTDOC
+	WmfEndDoc                  = GDIP_WMF_RECORD_TO_EMFPLUS(&h005E)   ' META_ENDDOC
+	WmfDeleteObject            = GDIP_WMF_RECORD_TO_EMFPLUS(META_DELETEOBJECT)
+	WmfCreatePalette           = GDIP_WMF_RECORD_TO_EMFPLUS(META_CREATEPALETTE)
+	WmfCreateBrush             = GDIP_WMF_RECORD_TO_EMFPLUS(&h00F8)   ' META_CREATEBRUSH
+	WmfCreatePatternBrush      = GDIP_WMF_RECORD_TO_EMFPLUS(META_CREATEPATTERNBRUSH)
+	WmfCreatePenIndirect       = GDIP_WMF_RECORD_TO_EMFPLUS(META_CREATEPENINDIRECT)
+	WmfCreateFontIndirect      = GDIP_WMF_RECORD_TO_EMFPLUS(META_CREATEFONTINDIRECT)
+	WmfCreateBrushIndirect     = GDIP_WMF_RECORD_TO_EMFPLUS(META_CREATEBRUSHINDIRECT)
+	WmfCreateBitmapIndirect    = GDIP_WMF_RECORD_TO_EMFPLUS(&h02FD)   ' META_CREATEBITMAPINDIRECT
+	WmfCreateBitmap            = GDIP_WMF_RECORD_TO_EMFPLUS(&h06FE)   ' META_CREATEBITMAP
+	WmfCreateRegion            = GDIP_WMF_RECORD_TO_EMFPLUS(META_CREATEREGION)
+
+	EmfHeader                  = EMR_HEADER
+	EmfPolyBezier              = EMR_POLYBEZIER
+	EmfPolygon                 = EMR_POLYGON
+	EmfPolyline                = EMR_POLYLINE
+	EmfPolyBezierTo            = EMR_POLYBEZIERTO
+	EmfPolyLineTo              = EMR_POLYLINETO
+	EmfPolyPolyline            = EMR_POLYPOLYLINE
+	EmfPolyPolygon             = EMR_POLYPOLYGON
+	EmfSetWindowExtEx          = EMR_SETWINDOWEXTEX
+	EmfSetWindowOrgEx          = EMR_SETWINDOWORGEX
+	EmfSetViewportExtEx        = EMR_SETVIEWPORTEXTEX
+	EmfSetViewportOrgEx        = EMR_SETVIEWPORTORGEX
+	EmfSetBrushOrgEx           = EMR_SETBRUSHORGEX
+	EmfEOF                     = EMR_EOF
+	EmfSetPixelV               = EMR_SETPIXELV
+	EmfSetMapperFlags          = EMR_SETMAPPERFLAGS
+	EmfSetMapMode              = EMR_SETMAPMODE
+	EmfSetBkMode               = EMR_SETBKMODE
+	EmfSetPolyFillMode         = EMR_SETPOLYFILLMODE
+	EmfSetROP2                 = EMR_SETROP2
+	EmfSetStretchBltMode       = EMR_SETSTRETCHBLTMODE
+	EmfSetTextAlign            = EMR_SETTEXTALIGN
+	EmfSetColorAdjustment      = EMR_SETCOLORADJUSTMENT
+	EmfSetTextColor            = EMR_SETTEXTCOLOR
+	EmfSetBkColor              = EMR_SETBKCOLOR
+	EmfOffsetClipRgn           = EMR_OFFSETCLIPRGN
+	EmfMoveToEx                = EMR_MOVETOEX
+	EmfSetMetaRgn              = EMR_SETMETARGN
+	EmfExcludeClipRect         = EMR_EXCLUDECLIPRECT
+	EmfIntersectClipRect       = EMR_INTERSECTCLIPRECT
+	EmfScaleViewportExtEx      = EMR_SCALEVIEWPORTEXTEX
+	EmfScaleWindowExtEx        = EMR_SCALEWINDOWEXTEX
+	EmfSaveDC                  = EMR_SAVEDC
+	EmfRestoreDC               = EMR_RESTOREDC
+	EmfSetWorldTransform       = EMR_SETWORLDTRANSFORM
+	EmfModifyWorldTransform    = EMR_MODIFYWORLDTRANSFORM
+	EmfSelectObject            = EMR_SELECTOBJECT
+	EmfCreatePen               = EMR_CREATEPEN
+	EmfCreateBrushIndirect     = EMR_CREATEBRUSHINDIRECT
+	EmfDeleteObject            = EMR_DELETEOBJECT
+	EmfAngleArc                = EMR_ANGLEARC
+	EmfEllipse                 = EMR_ELLIPSE
+	EmfRectangle               = EMR_RECTANGLE
+	EmfRoundRect               = EMR_ROUNDRECT
+	EmfArc                     = EMR_ARC
+	EmfChord                   = EMR_CHORD
+	EmfPie                     = EMR_PIE
+	EmfSelectPalette           = EMR_SELECTPALETTE
+	EmfCreatePalette           = EMR_CREATEPALETTE
+	EmfSetPaletteEntries       = EMR_SETPALETTEENTRIES
+	EmfResizePalette           = EMR_RESIZEPALETTE
+	EmfRealizePalette          = EMR_REALIZEPALETTE
+	EmfExtFloodFill            = EMR_EXTFLOODFILL
+	EmfLineTo                  = EMR_LINETO
+	EmfArcTo                   = EMR_ARCTO
+	EmfPolyDraw                = EMR_POLYDRAW
+	EmfSetArcDirection         = EMR_SETARCDIRECTION
+	EmfSetMiterLimit           = EMR_SETMITERLIMIT
+	EmfBeginPath               = EMR_BEGINPATH
+	EmfEndPath                 = EMR_ENDPATH
+	EmfCloseFigure             = EMR_CLOSEFIGURE
+	EmfFillPath                = EMR_FILLPATH
+	EmfStrokeAndFillPath       = EMR_STROKEANDFILLPATH
+	EmfStrokePath              = EMR_STROKEPATH
+	EmfFlattenPath             = EMR_FLATTENPATH
+	EmfWidenPath               = EMR_WIDENPATH
+	EmfSelectClipPath          = EMR_SELECTCLIPPATH
+	EmfAbortPath               = EMR_ABORTPATH
+	EmfReserved_069            = 69   ' Not Used
+	EmfGdiComment              = EMR_GDICOMMENT
+	EmfFillRgn                 = EMR_FILLRGN
+	EmfFrameRgn                = EMR_FRAMERGN
+	EmfInvertRgn               = EMR_INVERTRGN
+	EmfPaintRgn                = EMR_PAINTRGN
+	EmfExtSelectClipRgn        = EMR_EXTSELECTCLIPRGN
+	EmfBitBlt                  = EMR_BITBLT
+	EmfStretchBlt              = EMR_STRETCHBLT
+	EmfMaskBlt                 = EMR_MASKBLT
+	EmfPlgBlt                  = EMR_PLGBLT
+	EmfSetDIBitsToDevice       = EMR_SETDIBITSTODEVICE
+	EmfStretchDIBits           = EMR_STRETCHDIBITS
+	EmfExtCreateFontIndirect   = EMR_EXTCREATEFONTINDIRECTW
+	EmfExtTextOutA             = EMR_EXTTEXTOUTA
+	EmfExtTextOutW             = EMR_EXTTEXTOUTW
+	EmfPolyBezier16            = EMR_POLYBEZIER16
+	EmfPolygon16               = EMR_POLYGON16
+	EmfPolyline16              = EMR_POLYLINE16
+	EmfPolyBezierTo16          = EMR_POLYBEZIERTO16
+	EmfPolylineTo16            = EMR_POLYLINETO16
+	EmfPolyPolyline16          = EMR_POLYPOLYLINE16
+	EmfPolyPolygon16           = EMR_POLYPOLYGON16
+	EmfPolyDraw16              = EMR_POLYDRAW16
+	EmfCreateMonoBrush         = EMR_CREATEMONOBRUSH
+	EmfCreateDIBPatternBrushPt = EMR_CREATEDIBPATTERNBRUSHPT
+	EmfExtCreatePen            = EMR_EXTCREATEPEN
+	EmfPolyTextOutA            = EMR_POLYTEXTOUTA
+	EmfPolyTextOutW            = EMR_POLYTEXTOUTW
+	EmfSetICMMode              = 98   ' EMR_SETICMMODE
+	EmfCreateColorSpace        = 99   ' EMR_CREATECOLORSPACE
+	EmfSetColorSpace           = 100  ' EMR_SETCOLORSPACE
+	EmfDeleteColorSpace        = 101  ' EMR_DELETECOLORSPACE
+	EmfGLSRecord               = 102  ' EMR_GLSRECORD
+	EmfGLSBoundedRecord        = 103  ' EMR_GLSBOUNDEDRECORD
+	EmfPixelFormat             = 104  ' EMR_PIXELFORMAT
+	EmfDrawEscape              = 105  ' EMR_RESERVED_105
+	EmfExtEscape               = 106  ' EMR_RESERVED_106
+	EmfStartDoc                = 107  ' EMR_RESERVED_107
+	EmfSmallTextOut            = 108  ' EMR_RESERVED_108
+	EmfForceUFIMapping         = 109  ' EMR_RESERVED_109
+	EmfNamedEscape             = 110  ' EMR_RESERVED_110
+	EmfColorCorrectPalette     = 111  ' EMR_COLORCORRECTPALETTE
+	EmfSetICMProfileA          = 112  ' EMR_SETICMPROFILEA
+	EmfSetICMProfileW          = 113  ' EMR_SETICMPROFILEW
+	EmfAlphaBlend              = 114  ' EMR_ALPHABLEND
+	EmfSetLayout               = 115  ' EMR_SETLAYOUT
+	EmfTransparentBlt          = 116  ' EMR_TRANSPARENTBLT
+	EmfReserved_117            = 117  ' Not Used
+	EmfGradientFill            = 118  ' EMR_GRADIENTFILL
+	EmfSetLinkedUFIs           = 119  ' EMR_RESERVED_119
+	EmfSetTextJustification    = 120  ' EMR_RESERVED_120
+	EmfColorMatchToTargetW     = 121  ' EMR_COLORMATCHTOTARGETW
+	EmfCreateColorSpaceW       = 122  ' EMR_CREATECOLORSPACEW
+	EmfMax                     = 122
+	EmfMin                     = 1
+
+	EmfPlusInvalid = GDIP_EMFPLUS_RECORD_BASE
+	EmfPlusHeader
+	EmfPlusEndOfFile
+
+	EmfPlusComment
+
+	EmfPlusGetDC
+
+	EmfPlusMultiFormatStart
+	EmfPlusMultiFormatSection
+	EmfPlusMultiFormatEnd
+
+	EmfPlusObject
+
+	EmfPlusClear
+	EmfPlusFillRects
+	EmfPlusDrawRects
+	EmfPlusFillPolygon
+	EmfPlusDrawLines
+	EmfPlusFillEllipse
+	EmfPlusDrawEllipse
+	EmfPlusFillPie
+	EmfPlusDrawPie
+	EmfPlusDrawArc
+	EmfPlusFillRegion
+	EmfPlusFillPath
+	EmfPlusDrawPath
+	EmfPlusFillClosedCurve
+	EmfPlusDrawClosedCurve
+	EmfPlusDrawCurve
+	EmfPlusDrawBeziers
+	EmfPlusDrawImage
+	EmfPlusDrawImagePoints
+	EmfPlusDrawString
+
+	EmfPlusSetRenderingOrigin
+	EmfPlusSetAntiAliasMode
+	EmfPlusSetTextRenderingHint
+	EmfPlusSetTextContrast
+	EmfPlusSetInterpolationMode
+	EmfPlusSetPixelOffsetMode
+	EmfPlusSetCompositingMode
+	EmfPlusSetCompositingQuality
+	EmfPlusSave
+	EmfPlusRestore
+	EmfPlusBeginContainer
+	EmfPlusBeginContainerNoParams
+	EmfPlusEndContainer
+	EmfPlusSetWorldTransform
+	EmfPlusResetWorldTransform
+	EmfPlusMultiplyWorldTransform
+	EmfPlusTranslateWorldTransform
+	EmfPlusScaleWorldTransform
+	EmfPlusRotateWorldTransform
+	EmfPlusSetPageTransform
+	EmfPlusResetClip
+	EmfPlusSetClipRect
+	EmfPlusSetClipPath
+	EmfPlusSetClipRegion
+	EmfPlusOffsetClip
+
+	EmfPlusDrawDriverString
+
+	EmfPlusRecordTotal
+
+	EmfPlusRecordTypeMax = EmfPlusRecordTotal - 1
+'	EmfPlusRecordTypeMin = EmfPlusRecordTypeHeader
+End Enum
+
 End Namespace
 End Namespace